#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QShortcut>
#include <QDialog>
#include <QDialogButtonBox>
#include <QFormLayout>
#include <QLineEdit>
#include <QFile>
#include <QTextStream>

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    ui->lineEdit->setPlaceholderText("Enter the command");
    connect(ui->pushButton, SIGNAL(clicked()), this, SLOT(ok_clicked()));
    connect(ui->pushButton_2, SIGNAL(clicked()), this, SLOT(clear_clicked()));
    QShortcut *shortcut = new QShortcut(QKeySequence("Enter"), this); //пытался хоткей сделсть на ентер. Получилось на тот, что у нумпада
    QObject::connect(shortcut, SIGNAL(activated()), this, SLOT(ok_clicked())); //просто неудобно нажимать руками на ОК
}

void MainWindow::ok_clicked() {
    QString command = ui->lineEdit->text();
    QSqlQuery query;
    bool cmd = query.exec(command);

     ui->textEdit_log->append(command);
     ui->textEdit_log->append("\n");

    if (!cmd) {
          ui->textEdit_log->append(query.lastError().text());
    }
}



void MainWindow::clear_clicked() {
    ui->lineEdit->clear();
}

MainWindow::~MainWindow()
{
    delete ui;
}


void MainWindow::on_actionExit_triggered()
{
    QApplication::quit();
}

void MainWindow::on_actionConnect_triggered()
{
    QDialog dlg(this);
    dlg.setWindowTitle(tr("Connect configuration"));
    dlg.isModal(); //делаем приоритетным окном
    dlg.setWindowFlags (dlg.windowFlags() & ~Qt::WindowContextHelpButtonHint); //убираем знак вопроса
    QLineEdit *SqlDatabase = new QLineEdit(&dlg);
    QLineEdit *HostName = new QLineEdit(&dlg);
    QLineEdit *DatabaseName = new QLineEdit(&dlg);
    QLineEdit *UserName = new QLineEdit(&dlg);
    QLineEdit *Password = new QLineEdit(&dlg);
    QLineEdit *Port = new QLineEdit(&dlg);

    QDialogButtonBox *btn_box = new QDialogButtonBox(&dlg);
    btn_box->setStandardButtons(QDialogButtonBox::Ok | QDialogButtonBox::Cancel);

    connect(btn_box, &QDialogButtonBox::accepted, &dlg, &QDialog::accept);
    connect(btn_box, &QDialogButtonBox::rejected, &dlg, &QDialog::reject);

    QFormLayout *layout = new QFormLayout();
    layout->addRow(tr("SqlDatabase:"), SqlDatabase);
    layout->addRow(tr("HostName:"), HostName);
    layout->addRow(tr("DatabaseName:"), DatabaseName);
    layout->addRow(tr("UserName:"), UserName);
    layout->addRow(tr("Password:"), Password);
    layout->addRow(tr("Port:"), Port);
    layout->addWidget(btn_box);

    //Пошла работа с файлами
    QFile file("config.txt");

    if (file.open(QIODevice::ReadOnly)) {
        QTextStream in(&file);
        SqlDatabase->setText(in.readLine());
        HostName->setText(in.readLine());
        DatabaseName->setText(in.readLine());
        UserName->setText(in.readLine());
        Password->setText(in.readLine());
        Port->setText(in.readLine());
        file.close();
    }

    dlg.setLayout(layout);

    // В случае, если пользователь нажал "Ok".
    if(dlg.exec() == QDialog::Accepted) {
        \
       // коннектимся куда там хотели

        if(file.open(QIODevice::WriteOnly | QIODevice::Text))
            {
                QTextStream out(&file);
                out << SqlDatabase->text() << "\n";
                out << HostName->text() << "\n";
                out << DatabaseName->text() << "\n";
                out << UserName->text() << "\n";
                out << Password->text() << "\n";
                out << Port->text() << "\n";
                file.close();
        }
    }
}
